export interface PartialLogger {
    readonly error?: (message?: any, ...args: any[]) => void;
    readonly group?: (title?: string) => void;
    readonly groupCollapsed?: (title?: string) => void;
    readonly groupEnd?: () => void;
    readonly log: (message?: any, ...args: any[]) => void;
    readonly warn?: (message?: any, ...args: any[]) => void;
}
export interface Logger extends PartialLogger {
    readonly error: (message?: any, ...args: any[]) => void;
    readonly group: (title?: string) => void;
    readonly groupCollapsed: (title?: string) => void;
    readonly groupEnd: () => void;
    readonly log: (message?: any, ...args: any[]) => void;
    readonly warn: (message?: any, ...args: any[]) => void;
}
export declare const defaultLogger: Console;
export declare function toLogger(partialLogger: PartialLogger): Logger;
