import { StackFrame } from "error-stack-parser";
import { Observable } from "rxjs";
import { SubscriberRef } from "../subscription-ref";
import { BasePlugin } from "./plugin";
export interface StackTraceRef {
    mappedStackTrace: Observable<StackFrame[]>;
    stackTrace: StackFrame[];
}
export declare function getMappedStackTrace(ref: SubscriberRef): Observable<StackFrame[]>;
export declare function getStackTrace(ref: SubscriberRef): StackFrame[];
export declare function getStackTraceRef(ref: SubscriberRef): StackTraceRef;
export declare class StackTracePlugin extends BasePlugin {
    private sourceCache_;
    private sourceMaps_;
    constructor({ sourceMaps }?: {
        sourceMaps?: boolean;
    });
    beforeSubscribe(ref: SubscriberRef): void;
    teardown(): void;
    private getStackFrames_;
}
